package com.javamonkey.test;

import java.lang.reflect.Method;

/*
 * Copyright (c) 2000 Kenamea, Inc.
 */

/**
 * 
 */
public abstract class ExpectTest extends BaseTest {

  public ExpectTest() {
    setName(getClass().getName());
  }

  public abstract Object[][] getTestData();
  public abstract ExpectTestRunner getTestRunner();
  
  public int getNumberOfTestCases() {
    return getTestData().length;
  }

  public void run() {
    Object[][] testdata = getTestData();
    ExpectTestRunner test = getTestRunner();

    String basename = getName() + "-";

    for (int i = 0; i < testdata.length; i++) {
      String name     = (String)testdata[i][0];
      Object arg      = testdata[i][1];
      Object expected = testdata[i][2];

      try {
	Object result = test.run(arg);
	if (equals(expected, result)) {
	  reportSuccess(name, "ok.");
	} else {
	  reportFailure(
	    name, "Got '" + result + "'; expected '" + expected + "'");
	}
      } catch (TestAbortedException tae) {
	reportAbort(name, tae);
      } catch (PreconditionNotMetException pnme) {
	reportSkip(name);
      } catch (Exception e) {
	reportFailure(name, "Uncaught exception from test method", e);
      }
    }
  }

  private static boolean equals(Object a, Object b) {
    return a == null ? b == null : a.equals(b);
  }

}
