package com.javamonkey.utils;

public class Debug {

  /**
   * Assert a condition. Throws an AssertionError if
   * the condition is false.
   *
   * @param condition The condition that must be true.
   * @throws AssertionError if the condition is false.
   */
  public static void assert(boolean condition) {
    if (!condition) {
      throw new AssertionError("ASSERTION FAILED");
    }
  }

  /**
   * Assert a condition. Throws an AssertionError if
   * the condition is false.
   *
   * @param condition The condition that must be true.
   * @param message A message to include in the AssertionError.
   * @throws AssertionError if the condition is false.
   */
  public static void assert(boolean condition, String message) {
    if (!condition) {
      throw new AssertionError(message);
    }
  }

  /**
   * Panic. Moral equivalent of <code>assert(false)</code>.
   */
  public static void panic(String message) {
    throw new AssertionError("PANIC: " + message);
  }
}

