package com.javamonkey.test;

import java.util.Date;

/*
 * Copyright (c) 1999 Peter Seibel
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/**
 * Unit test for com.javamonkey.test.AutoTest.
 *
 * @version $Id: //depot/macaca/tests/com/javamonkey/test/AutoTestTest.java#2 $
 */
public class AutoTestTest extends AutoTest {

  static boolean staticInnerRun = false;
  boolean instanceInnerRun = false;
  boolean testOkRun = false;

  public boolean testRequire() {
    require("testOk");
    return testOkRun ? success() : failure("testOk not run.");
  }

  public boolean testOk() { 
    testOkRun = true;
    return success();
  }

  public boolean testStaticInnerRun() {
    return staticInnerRun
      ? success() : failure("StaticInnerTest not run.");
  }

  public boolean testInstanceInnerRun() {
    return instanceInnerRun
      ? success() : failure("InstanceInnerTest not run.");
  }

  public static class StaticInnerTest extends AutoTest {
    public boolean testOk1() {
      return staticInnerRun = true;
    }
    public boolean testOk2() {
      return staticInnerRun = true;
    }
    public boolean testOk3() {
      return staticInnerRun = true;
    }
  }

  public static class TimebombTest extends AutoTest {

    public Date timebomb() {
      return new Date(System.currentTimeMillis() + 1000 * 60 * 60 * 24);
    }

    public boolean testShouldFail() {
      return failure("This should have been protected by a timebomb.");
    }
  }

  public class InstanceInnerTest extends AutoTest {
    public boolean testOk() {
      return instanceInnerRun = true;
    }
  }

}








